
use <../utilities.scad>
use <../arc.scad>
$fn=64;

outer_diameter=22;
// diameter
// thickness of bearing inner wall
th=2;
// thickness of flexures.
fth=0.5;

// total number of degrees of movement before it hits the endstops.
// if you rely on this to keep the print from cracking then you will
// want to adjust this based on the filament and overall size of your print.
degreesplay=60;

printable=true;
// maximum overhang for printing. 45 degrees is very conservative and any 
// printer should be able to do it without support. If you are going to be
// using support, you can set this to 90 degrees for the most compact form.
max_overhang=45;

// height does not have to depend on printabe
height= outer_diameter * (printable ? 2.5 : 2);

// clearance between flexures, may need to adjust if your bridging is
// sloppy and they rub against each other.
flexure_clearance=2;

od=outer_diameter - th;
module shell() {
        linear_extrude(height=height,center=true)arc(od/2,th,360/2-degreesplay/2);
}



module flexures() {
        cube([fth,od,height/2 - flexure_clearance/2],center=true);
        stack(height/2 + height/4 + flexure_clearance/4,n=2)
                cube([od + 0.1,fth,height/4 - flexure_clearance/4],center=true);
}


squidth=(od+th)*2*sin(degreesplay/4)/4;
clearance=3;

module outer() {
        translate([0,0,clearance/2])difference(){
                union() {
                        cylinder(h=height/2 - clearance/2 ,r=od/2+2*th);
                        if(printable)
                        translate([0,0,-2*th])cylinder(h=2*th, r2=od/2+2*th, r1=od/2);
                }
                cylinder(h=height*10,r=od/2+th - 0.001,center=true);
                linear_extrude(height*10,center=true)arc(od/2 + th/2,th,360/2 +
                                degreesplay/2);
                if(printable)
                translate([0,0,squidth])rotate([0,max_overhang,0])bisect();
        }
}

rotate([0,0,45])flexures();

//shell();
//rotate([0,0,180])shell();

//outer();
//rotate([0,180,0])outer();
