
// should be larger than any dimension of final product.
infinity = 1000;

//rounded off rectangle
module sqround(size,r=1,is_outer=false,center=false,h=0,scale=1) {
        if(h) {
                linear_extrude(height=h,center=center)sqround(size,r=r,is_outer=is_outer,center=center,h=0,scale=scale);
        } else {
                off = is_outer ? r : 0;
                x = size[0] - 2*off;
                y = size[1] - 2*off;
                translate([off,off])hull() {
                        translate([x,0])circle(r=r);
                        translate([x,y])circle(r=r);
                        translate([0,y])circle(r=r);
                        circle(r=r);
                }
        }
}

module shaft(d,direction=0,angle = 0) {

        center = direction == 0;
        rotate([direction == -1 ? 180 : 0, 0, 0])cylinder(r=d/2, h=infinity, center = center);

}

module quadrant(ld="x") {
        translate([ld == "x" ? - infinity/2 : 0, ld == "y" ? - infinity/2 :
        0, ld ==
        "z" ? - infinity / 2 : 0])cube([infinity,infinity,infinity]);
}
module bisect(ld="x") {
        translate([ld != "x" ? - infinity/2 : 0, ld != "y" ? - infinity/2 :
        0, ld !=
        "z" ? - infinity / 2 : 0])cube([infinity,infinity,infinity]);
}

module constellation(r,n=4,angle=0,align_point=false) {
        offset = 360/n;
        rotate([0,0,align_point ? 0: offset/2]) {
        for(i = [0 : n - 1]) {
                rotate([0,0,i*360/n])translate([0,-r,0])children();
        }
        }
}
module column(d,n=4,center = true) {
        total = d * (n - 1);

        translate([0,(center ? (-total/2) : 0),0]){
                for(i = [0 : n - 1]) {
                        translate([0,d*i,0])children();
                }
        }
}
module stack(d,n=4,center = true) {
        total = d * (n - 1);

        translate([0,0,center ? (-total/2) : 0]){
                for(i = [0 : n - 1]) {
                        translate([0,0,d*i])children();
                }
        }
}
module row(d,n=4) {
        total = d * n;
        translate([-total/2,0,0]){
                for(i = [0 : n - 1]) {
                        translate([d*i,0,0])children();
                }
        }
}
